routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

Use App\Http\Controllers\Admin\UserController as AdminUserController;
Use App\Http\Controllers\Admin\CommentController as AdminCommentController;
Use App\Http\Controllers\Admin\PictureController as AdminPictureController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::middleware('language')->group(function () {

    Auth::routes();
    Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('pictures', \App\Http\Controllers\PictureController::class)->except('edit', 'update');

    Route::resource('users', \App\Http\Controllers\UserController::class)->only('show', 'edit', 'update');

    Route::resource('comments', \App\Http\Controllers\CommentController::class)->except('index', 'create');






Route::prefix('admin')->name('admin.')->middleware(['auth', 'is_admin'])->group(function () {
    Route::resources([
        'users' => AdminUserController::class,
        'comments' => AdminCommentController::class,
        'pictures' => AdminPictureController::class
    ]);
});


Route::post('/admin/{user}/admin', [AdminUserController::class, 'admin'])->name('admin.users.admin');

});
Route::get('language/{local}', [\App\Http\Controllers\LanguageSwitchController::class, 'switcher'])->name('language.switcher')->where('locale', 'en|ru|es|fr|kg');

app/Models/Comment.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class Comment extends Model
{
    use HasFactory;

    protected $fillable = ['content', 'user_id', 'picture_id', 'grade'];


    /**
     * @return BelongsTo
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return BelongsTo
     */
    public function picture()
    {
        return $this->belongsTo(Picture::class);
    }
}

app/Http/Controllers/Admin/CommentController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\CommentTableEditRequest;
use App\Http\Requests\CommentTableStoreRequest;
use App\Models\Comment;
use App\Models\Picture;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class CommentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index()
    {
        $comments = Comment::all();
        return view('admin.comments.index', compact('comments'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View
     */
    public function create()
    {
        $pictures = Picture::all();
        return view('admin.comments.create', compact('pictures'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param Request $request
     * @return RedirectResponse
     */
    public function store(CommentTableStoreRequest $request)
    {
        $comment = new Comment($request->all());
        $comment->user_id = Auth::id();
        $comment->save();
        return redirect()->route('admin.comments.index')->with('success', __('Successfully created'));
    }

    /**
     * Display the specified resource.
     *
     * @param Comment $comment
     * @return Application|Factory|View
     */
    public function show(Comment $comment)
    {
        return view('admin.comments.show', compact('comment'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Comment $comment
     * @return Application|Factory|View
     */
    public function edit(Comment $comment)
    {
       return view('admin.comments.edit', compact('comment'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param Request $request
     * @param Comment $comment
     * @return RedirectResponse
     */
    public function update(CommentTableEditRequest $request, Comment $comment)
    {
        $comment->update($request->all());
        $comment->save();
        return redirect()->route('admin.comments.index')->with('success', __('Successfully updated'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Comment $comment
     * @return RedirectResponse
     */
    public function destroy(Comment $comment)
    {
        $comment->delete();
        return redirect()->back()->with('success', __('Successfully deleted'));
    }
}

app/Http/Controllers/Api/CommentsController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Requests\CommentTableEditRequest;
use App\Http\Requests\CommentTableStoreRequest;
use App\Http\Resources\CommentResource;
use App\Models\Comment;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application as ApplicationAlias;
use Illuminate\Contracts\Routing\ResponseFactory;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;
use Illuminate\Http\Response;

class CommentsController extends Controller
{

    /**
     * ArticleController constructor.
     */
    public function __construct()
    {
        return $this->middleware('auth:api');
    }
    /**
     * Display a listing of the resource.
     *
     * @return AnonymousResourceCollection
     */
    public function index()
    {
        $comments = Comment::paginate(3);
        return CommentResource::collection($comments);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param CommentTableStoreRequest $request
     * @return JsonResponse
     */
    public function store(CommentTableStoreRequest $request)
    {
        $data = $request->all();
        $data['user_id'] = auth('api')->user()->id;
        $comment = Comment::create($data);
        return response()->json(new CommentResource($comment), 201);
    }

    /**
     * Display the specified resource.
     *
     * @param Comment $comment
     * @return CommentResource
     */
    public function show(Comment $comment)
    {
        return new CommentResource($comment);
    }


    /**
     * Update the specified resource in storage.
     *
     * @param Request $request
     * @param Comment $comment
     * @return CommentResource
     * @throws AuthorizationException
     */
    public function update(CommentTableEditRequest $request, Comment $comment)
    {
        $this->authorize('update', $comment);
        $comment->update($request->validated());
        $comment->fresh();
        return new CommentResource($comment);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Comment $comment
     * @return ApplicationAlias|ResponseFactory|Response
     * @throws AuthorizationException
     */
    public function destroy(Comment $comment)
    {
        $this->authorize('delete', $comment);
        $comment->delete();
        return response([], 204);
    }
}

app/Http/Controllers/CommentController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CommentTableEditRequest;
use App\Http\Requests\CommentTableStoreRequest;
use App\Models\Comment;
use App\Models\Picture;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Support\Facades\Auth;

class CommentController extends Controller
{

    /**
     * Store a newly created resource in storage.
     *
     * @param CommentTableStoreRequest $request
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function store(CommentTableStoreRequest $request)
    {
        $this->authorize('restore', Picture::find($request->input('picture_id')));
        $comment = new Comment($request->all());
        $comment->user_id = Auth::id();
        $comment->save();
        return redirect()->back()->with('success', __('Successfully created'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Comment $comment
     * @return Application|Factory|View
     */
    public function edit(Comment $comment)
    {
        $this->authorize('update', $comment);
        return view('client.comments.edit', compact('comment'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param CommentTableEditRequest $request
     * @param Comment $comment
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function update(CommentTableEditRequest $request, Comment $comment)
    {
        $this->authorize('update', $comment);
        $comment->update($request->all());
        return redirect()->route('pictures.show', ['picture' => $comment->picture])->with('success', __('Successfully updated'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Comment $comment
     * @return RedirectResponse
     */
    public function destroy(Comment $comment)
    {
        $this->authorize('delete', $comment);
        $comment->delete();
        return redirect()->back()->with('success', __('Successfully deleted'));
    }
}

resources/views/admin/comments/create.blade.php
@extends('layouts.app')

@section('content')

    <div class="mt-5">
        <h4>{{ __('Add Comment') }}</h4>
        <form action="{{route('admin.comments.store')}}" method="POST">
            @csrf
            <div class="mb-3">
                <label for="content" class="form-label">{{__('Content')}}</label>
                <input name="content" type="text"
                       class="form-control @if($errors->has('content')) is-invalid @endif"
                       id="content" aria-describedby="content">
                <div id="content" class="form-text">Please, enter your comment</div>
                @error('content')
                <p class="text-danger">{{$message}}</p>
                @enderror
            </div>
            <label for="grade" class="form-label">{{__('Grade')}}</label>
            <select name="grade" class="form-select mb-3 w-25 @if($errors->has('grade')) is-invalid @endif"
                    aria-label="Default select example">
                <option selected>Open this select menu</option>
                <option value="1">1</option>
                <option value="2">2</option>
                <option value="3">3</option>
                <option value="4">4</option>
                <option value="5">5</option>
            </select>
            @error('grade')
            <p class="text-danger">{{$message}}</p>
            @enderror
            <label for="picture_id" class="form-label">{{__('Picture')}}</label>
            <select name="picture_id" class="form-select mb-3 w-25 @if($errors->has('picture_id')) is-invalid @endif"
                    aria-label="Default select example">
                @foreach($pictures as $picture)
                    <option value={{$picture->id}}>{{$picture->name}}</option>
                @endforeach
            </select>
            @error('picture_id')
            <p class="text-danger">{{$message}}</p>
            @enderror
            <button type="submit" class="btn btn-primary">{{ __('Save') }}</button>
        </form>
    </div>

@endsection

resources/views/admin/comments/edit.blade.php
@extends('layouts.app')

@section('content')

    <div class="mt-5">
        <h4>{{ __('Edit') }}</h4>
        <form action="{{route('admin.comments.update', ['comment' => $comment])}}" method="POST">
            @csrf
            @method('PUT')
            <div class="mb-3">
                <label for="content" class="form-label">{{__('Content')}}</label>
                <input value="{{$comment->content}}" name="content" type="text" class="form-control @if($errors->has('content')) is-invalid @endif" id="content" aria-describedby="content">
                <div id="content" class="form-text">{{__('Please, enter your comment')}}</div>
                @error('content')
                <p class="text-danger">{{$message}}</p>
                @enderror
            </div>
            <label for="grade" class="form-label">{{__('Grade')}}</label>
            <select name="grade" class="form-select mb-3 w-25 @if($errors->has('grade')) is-invalid @endif" aria-label="Default select example">
                <option @if($comment->grade == 1) selected  @endif value="1">1</option>
                <option @if($comment->grade == 2) selected  @endif value="2">2</option>
                <option @if($comment->grade == 3) selected  @endif value="3">3</option>
                <option @if($comment->grade == 4) selected  @endif value="4">4</option>
                <option @if($comment->grade == 5) selected  @endif value="5">5</option>
            </select>
            @error('grade')
            <p class="text-danger">{{$message}}</p>
            @enderror
            <button type="submit" class="btn btn-primary">{{ __('Save') }}</button>
        </form>
    </div>

@endsection

resources/views/admin/comments/index.blade.php
@extends('layouts.app')
@section('content')
    @include('admin.navbar.navbar')


    <div>
        <h4>{{__('Create new comment')}} <a class="btn btn-outline-primary" href="{{route('admin.comments.create')}}">{{__('Create')}}</a></h4>
    </div>

    <table class="table table-dark">
        <thead>
        <tr>
            <th scope="col">ID</th>
            <th scope="col">{{__('Name')}}</th>
            <th scope="col">{{__('Grade')}}</th>
            <th scope="col">{{__('Picture')}}</th>
            <th scope="col">{{__('Actions')}}</th>
        </tr>
        </thead>
        <tbody>
        @foreach($comments as $comment)
            <tr>
                <th scope="row">{{$comment->id}}</th>
                <td>{{$comment->user->name}}</td>
                <td>{{$comment->grade}}</td>
                <td>{{$comment->picture->name}}</td>
                <td style="display: flex;">
                    <a class="btn btn-outline-info"
                       href="{{route('admin.comments.edit', ['comment' => $comment])}}">{{__('Edit')}}</a>
                    <a class="btn btn-outline-warning mx-3" href="{{route('admin.comments.show', ['comment' => $comment])}}">
                        {{__('Show')}}
                    </a>
                        <form method="post" action="{{route('admin.comments.destroy', ['comment' => $comment])}}">
                            @method('delete')
                            @csrf
                            <button type="submit" class="btn btn-outline-danger">{{__('Delete')}}</button>
                        </form>
                </td>
            </tr>
        @endforeach
        </tbody>
    </table>
@endsection

resources/views/admin/comments/show.blade.php
@extends('layouts.app')

@section('content')

    <div class="card mt-3">

        <div class="card-header">
            <h5>{{__('Author')}}: {{$comment->user->name}}</h5>
        </div>
        <div class="card-body">
            <h6>{{__('Grade')}}: {{$comment->grade}}</h6>
            <p class="card-text">{{$comment->content}}</p>
            <p>{{$comment->created_at->diffForHumans()}}</p>
        </div>
    </div>

@endsection